//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#include <cstdlib>
#include <iostream>

using namespace std;

//----------------------------------------------------------------------------

// a super-exciting class which holds, very carefully, one precious variable

template<typename T>
class Unit
{
public:
  Unit() { }
  Unit(T);
  
  void set(T);
  T get();
  void print() { cout << value << endl; }

private:
  T value;
};

//----------------------------------------------------------------------------

// function templates for members...

template<typename T>
Unit<T>::Unit(T val)
{
  value = val;
}

//----------------------------------------------------------------------------

// function templates for members...

template<typename T>
void Unit<T>::set(T val)
{
  value = val;
}

//----------------------------------------------------------------------------

// function templates for members...

template<typename T>
T Unit<T>::get()
{
  return value;
}

//----------------------------------------------------------------------------

// function templates for members...

/*
template<typename T>
void Unit<T>::print()
{
  cout << value << endl;
}
*/

//----------------------------------------------------------------------------

void example1()
{
  Unit <int> x;
  x.set(10);
  x.print();
  /*
  cout << x.get() << endl;

  Unit <string> s("panda");
  cout << s.get() << endl;

  Unit <char> *c;
  c = new Unit<char>('%');
  cout << c->get() << endl;
  */
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

template<typename T>
class GeneralArray
{
public:
  GeneralArray(T [], int);
  
  void print();
  T smallest_element();

private:
  T *array;
  int size;
};

//----------------------------------------------------------------------------

template<typename T>
GeneralArray<T>::GeneralArray(T *arr, int n)
{
  size = n;
  array = new T[size];

  for (int i = 0; i < size; i++)
    array[i] = arr[i];
}

//----------------------------------------------------------------------------

template<typename T>
void GeneralArray<T>::print()
{
  for (int i = 0; i < size; i++)
    cout << array[i] << endl;
}

//----------------------------------------------------------------------------

template<typename T>
T GeneralArray<T>::smallest_element()
{
  int i;
  T smallest_so_far;

  smallest_so_far = array[0];
  for (i = 1; i < size; i++)
    if (array[i] < smallest_so_far)
      smallest_so_far = array[i];

  return smallest_so_far;
}

//----------------------------------------------------------------------------

void example2()
{
  int A[5] = { 7, 9, 2, 10, 23 };

  string S[5] = { "umbrella",
		  "stingray",
		  "bicycle",
		  "aardvark",
		  "rainbow" };

  GeneralArray <int> GA(A, 5);
  GA.print();
  cout << "**" << GA.smallest_element() << "**" << "\n\n";

  GeneralArray <string> GS(S, 5);
  GS.print();
  cout << "**" << GS.smallest_element() << "**" << "\n";
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// container "node" which holds some data cargo and points to another node

template<typename T>
class Node
{
public:
  Node(T v) { value = v; link = NULL; }

  // make a link to a new node with value v

  void add(T v) 
  {
    if (link == NULL)
      link = new Node<T>(v);
    else
      link->add(v);      // recursion!!
  }

  // print this node and all linked nodes

  void print() 
  { 
    cout << value << endl;  
    if (link != NULL)
      link->print();     // recursion!!
    else
      cout << endl;
  }

private:
  T value;
  Node<T> *link;
};

//----------------------------------------------------------------------------

void example3()
{
  Node <char> N('c');

  N.print();
  N.add('a');
  N.print();
  N.add('t');
  N.print();

  Node <string> M("burger");

  M.print();
  M.add("fries");
  M.print();
  M.add("shake");
  M.print();
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

int main(int argc, char** argv)
{
  //  example1();
  example2();
  //example3();

  return 1;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
